var http = require('http');
var tap = require('tap');

module.exports = webtap;

function webtap (server) {
  if (typeof server == 'function') server = http.createServer(server);

  return function test (name, method, path, cb) {
    var args = [].slice.call(arguments);
    cb = args.pop();
    path = args.pop();
   
    // method / path shorthand
    var match = path.match(/^([a-zA-Z]+) (\/(.*))$/);
    if (match) {
      method = match[1];
      path = match[2];
    } else {
      method = args.pop();
    }

    var name = args.pop();

    tap.test(name || method + ' ' + path, function (t) {
      server.listen(function () {
        var opts = {
          hostname : 'localhost',
          port : server.address().port,
          path : path,
          method : method
        }
        var req = http.request(opts, function (res) {
          t.body = body;

          var oldEnd = t.end;
          t.end = function () {
            server.close(oldEnd.bind(t));
          };

          cb(t, res);

          function body (str, msg) {
            var data = '';
            res.on('data', function (d) { data += d });
            res.on('end', function () {
              if (typeof str == 'string') {
                t.equal(data, str, msg);
              } else {
                var parsed;
                try {
                  parsed = JSON.parse(data);
                } catch (err) {
                  t.error(err, 'error parsing JSON');
                }

                t.deepEqual(parsed, str, msg);
              }
              t.end();
            });
          }
        })
        req.on('error', console.log);
        req.end();
      });
    });
  }
}
